/*
 * $Id:$
 */

/**
 * @author Michael Kroll, michael.kroll@trantor.de
 */

package javax.microedition.io;

import java.io.*;

public interface FileConnection extends StreamConnection {

	public long availableSize();

	public boolean canRead();

	public boolean canWrite();

	public boolean create() throws IOException;

	public boolean delete() throws IOException;

	public long directorySize(boolean includeSubDirs) throws IOException;

	public boolean exists();

	public long fileSize() throws IOException;

	public String getPath();

	public String getURL();

	public boolean isDirectory();

	public boolean isHidden();

	public long lastModified();

	public String[] list() throws IOException;
	
	public String[] list(String filter, boolean includeHidden) throws IOException;

	public boolean mkdir() throws IOException;

	public boolean rename(java.lang.String newName) throws IOException;

	public void truncate(int byteOffset) throws IOException;

	public void setHidden(boolean hidden) throws IOException;

	public void setReadable(boolean readable) throws IOException;

	public void setWriteable(boolean writable) throws IOException;

	public long totalSize();

	public long usedSize();
}

/*
 * $Log:$
 */