/*
 * $Id:$
 */

/**
 * @author Michael Kroll, michael.kroll@trantor.de
 */

package javax.microedition.io;

import java.io.*;
import java.util.*;
import org.me4se.impl.gcf.*;
import org.me4se.impl.gcf.*;

import org.me4se.impl.gcf.*;

public class FileSystemRegistry {

	static FileSystemListener fslistener;

	static class ListenThread extends Thread {

		Hashtable roots = new Hashtable();

		public void run() {

			String[] list = FileSystemRegistry.listRoots();

			for (int i = 0; i < list.length; i++) {
				roots.put(list[i], list[i]);
			}

			while (FileSystemRegistry.fslistener != null) {
				list = FileSystemRegistry.listRoots();

				// new root has beed added
				if (list.length > roots.size()) {
					for (int i = 0; i < list.length; i++) {
						if (roots.get(list[i]) == null) {
							roots.put(list[i], list[i]);

							fslistener.rootChanged(FileSystemListener.ROOT_ADDED, list[i]);

							break;
						}
					}

				}
				// root has been removed
				else if (list.length < roots.size()) {
					for (int i = 0; i < list.length; i++) {
						roots.remove(list[i]);
					}
					String removedRoot = (String) roots.elements().nextElement();
					fslistener.rootChanged(FileSystemListener.ROOT_REMOVED, removedRoot);
					roots = new Hashtable();
					for (int i = 0; i < list.length; i++) {
						roots.put(list[i], list[i]);
					}
				}
				try {
					sleep(2500);
				}
				catch (InterruptedException e) {
				}
			}
		}
	}

	private FileSystemRegistry() {
	}

	public static void addFileSystemListener(FileSystemListener listener) {
		fslistener = listener;
		new ListenThread().start();
	}

	public static String[] listRoots() {

		char slash = '/';
		char c;

		Vector v = new Vector();

		// necessary since jdk1.1.x does not support File.listRoots()
		// solution on ME4SE_WINCE and ME4SE_EPOC needed !?!

		for (c = 'c'; c <= 'z'; c++) {
			String driveName = new String(c + ":");
			File rootDir = new File(driveName + slash);
			if ((rootDir != null) && (rootDir.exists())) {
				v.addElement(driveName.toUpperCase() + File.separatorChar);
			}
		}

		String[] roots = new String[v.size()];

		for (int i = 0; i < roots.length; i++) {
			String root = (String) v.elementAt(i);
			root = root.substring(0, root.length() - 1) + "/";
			roots[i] = root;
		}
		return roots;
	}

	public static void removeFileSystemListener(FileSystemListener listener) {
		listener = null;
	}
}

/*
 * $Log:$
 */