package javax.microedition.lcdui;

import org.me4se.impl.lcdui.*;
import java.awt.event.KeyEvent;

class GaugeComponent extends DeviceComponent {

    Gauge gauge;

    GaugeComponent (Gauge gauge, boolean interactive) {
	super (interactive ? "gauge" : "interactiveGauge", interactive); 
	this.gauge = gauge;
    }

    public boolean keyPressed(int code, int mask) {
	if (getFocusable ()) {

	    if (code == KeyEvent.VK_LEFT && gauge.value > 0) {
		gauge.value--;
		repaint ();
		return true;
	    }
	    else if (code == KeyEvent.VK_RIGHT 
		     && gauge.value < gauge.maximum) {
		gauge.value++;
		repaint ();
		return true;
	    }
	}
	return super.keyPressed (code, mask);
    }

    public void paint (java.awt.Graphics g) {
	super.paint (g);
	

	if (getFocusable () && hasFocus ()) {
	    int m = getHeight()/2;
	    
	    for (int i = 0; i < 4; i++) {
		g.drawLine (i, m-i, i, m+i);
		g.drawLine (getWidth()-1-i, m-i, getWidth()-1-i, m+i);
	    }
	}

	g.setColor (getFontInfo ().foreground);

	int w = getWidth () - 13;
	int h = getHeight () - 3;
	
	g.drawRect (6, 1, w, h);

	int mx = (w * gauge.value) / gauge.maximum;
	g.fillRect (6, 2, mx, h);
    }
}


