// ME4SE - A MicroEdition Emulation for J2SE
//
// Copyright (C) 2001 Stefan Haustein, Oberhausen (Rhld.), Germany
//
// Contributors:
//
// STATUS: API Complete
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version. This program is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details. You should have received a copy of the
// GNU General Public License along with this program; if not, write
// to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

package javax.microedition.lcdui;

import org.kobjects.scm.*;

public class ImageItem extends Item {

    public static final int LAYOUT_DEFAULT = 0;
    public static final int LAYOUT_LEFT = 1;
    public static final int LAYOUT_RIGHT = 2;
    public static final int LAYOUT_CENTER = 3;
    public static final int LAYOUT_NEWLINE_BEFORE = 0x0100;
    public static final int LAYOUT_NEWLINE_AFTER = 0x0200;

    Image image;
    String alt;
    int layout;
    Wrapper wrapper = new Wrapper();

    class Wrapper extends ScmComponent {
        public void paint(java.awt.Graphics g) {
            if (image != null)
                g.drawImage(image._image, 0, 0, null);
        }

        public java.awt.Dimension getMinimumSize() {
            if (image == null) return new java.awt.Dimension (0,0);
            
            javax.microedition.midlet.ApplicationManager.manager.waitForImage (image._image, image.name);
            return new java.awt.Dimension(image.getWidth(), image.getHeight());
        }

        public java.awt.Dimension getPreferredSize() {
            return getMinimumSize();
        }
    }

    public ImageItem(String label, Image img, int layout, String alt) {
        super(label);

        setImage(img);
        setLayout(layout);
        this.alt = alt;
        lines.addElement(wrapper);
    }

    public String getAltText() {
        return alt;
    }

    public Image getImage() {
        return image;
    }

    public int getLayout() {
        return layout;
    }

    public void setAltText(String s) {
        alt = s;
    }

    public void setImage(Image img) {

        if (img != null) {
            if (img.mutable)
                throw new IllegalArgumentException();
        }
        this.image = img;
        wrapper.invalidate();
        //	wrapper.setSize (img.getWidth (), img.getHeight ());
    }

    public void setLayout(int l) {
        if ((l & ~0x0303) != 0)
            throw new IllegalArgumentException();

        layout = l;
    }
}
