// ME4SE - A MicroEdition Emulation for J2SE 
//
// Copyright (C) 2001 Stefan Haustein, Oberhausen (Rhld.), Germany
//
// Contributors:
//
// STATUS: API complete, optional image functionality missing
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version. This program is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details. You should have received a copy of the
// GNU General Public License along with this program; if not, write
// to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

package javax.microedition.lcdui;

import org.me4se.impl.lcdui.*;
import java.util.Vector;
import java.awt.event.*;
import org.kobjects.scm.*;

public class List extends Screen implements Choice {

    public static final Command SELECT_COMMAND = new Command("", Command.SCREEN, 0);

    int type;
    DeviceList list = new DeviceList(this);
    ScmScrollPane scrollPane = new ScmScrollPane();
    Vector group;

    ActionListener listener = new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
            handleCommand(SELECT_COMMAND);
        }
    };

    public List(String title, int listType) {
        super(title);
        type = listType;
        if (type != MULTIPLE)
            group = new Vector();
            
        scrollPane.add (list);
	ScmScrollBar sb = new ScmScrollBar ();
	sb.setBackground (javax.microedition.midlet.ApplicationManager.manager.bgColor);
	scrollPane.setVerticalBar (sb);
        container.setMain (scrollPane);

        selectButtonRequired = true;
        /*	list.addItemListener (new ItemListener () {
        	public void itemStateChanged (ItemEvent ev) {
        	}
        	});*/

     //   CursorAdapter.register(list, true);
     //   list.addKeyListener(eventHandler);
        container.updateButtons();
        
    }

    public List(
        String title,
        int listType,
        String[] stringElements,
        Image[] imageElements) {

        this(title, listType);

        for (int i = 0; i < stringElements.length; i++)
            append(stringElements[i], imageElements == null ? null : imageElements[i]);
    }

    public int append(String s, Image i) {
        insert(size(), s, i);
        return size() - 1;
    }

    public void delete(int index) {
        if (index >= size() || index < 0)
            throw new IndexOutOfBoundsException();
        if (group != null)
            group.removeElementAt(index);
        list.remove(index);
    }

    DeviceLabel getLabel(int index) {
        if (index >= size() || index < 0)
            throw new IndexOutOfBoundsException();
        return (DeviceLabel) list.getComponent(index);
    }

    public Image getImage(int index) {
        return (Image) getLabel(index).object;
    }

    public int getSelectedFlags(boolean[] flags) {
        int cnt = size();

        for (int i = 0; i < cnt; i++)
            flags[i] = isSelected(i);

        for (int i = cnt; i < flags.length; i++)
            flags[i] = false;

        return cnt;
    }

    public int getSelectedIndex() {
        if (type != MULTIPLE) {
            for (int i = 0; i < size(); i++)
                if (isSelected(i))
                    return i;
         
            if (type == IMPLICIT) {
                for (int i = 0; i < size(); i++)
                    if (getLabel (i).hasFocus ())
                        return i;
            }            
        }
        return -1;
    }

    public String getString(int index) {
        return getLabel(index).getText();
    }

    public void insert(int index, String stringItem, Image imageItem) {
        if (index > size() || index < 0)
            throw new IndexOutOfBoundsException();
        DeviceLabel label = new DeviceLabel("item", true);
	label.selectButtonRequired = true;
        label.setText(stringItem);
        if (imageItem != null) {
            label.object = imageItem;
            label.image = imageItem._image;
        }
        label.highlight = true;
        label.checkbox = type != IMPLICIT;
 //       label.addKeyListener(eventHandler);

        if (type == IMPLICIT)
           label.addActionListener(listener);

        if (group != null) {
            group.addElement(label);
            label.group = group;
        }

        list.add(label, index);
    }

    public boolean isSelected(int index) {
        return getLabel(index).selected();
    }

    public void set(int index, String str, Image img) {
        boolean sel = isSelected(index);
        delete(index);
        insert(index, str, img);
        setSelectedIndex(index, sel);
    }

    public void setSelectedFlags(boolean[] flags) {

        for (int i = 0; i < size(); i++) {
            getLabel(i).select(flags[i]);
            if (group != null && flags[i])
                return;
        }
    }

    public void setSelectedIndex(int i, boolean state) {
        getLabel(i).select(state);
    }

    public int size() {
        return list.getComponentCount();
    }


    public String toString () {
        StringBuffer buf = new StringBuffer (getClass() + "(lcduiList)[");
        for (int i = 0; i < size (); i++) {
            if (i > 0) buf.append (',');
            buf.append (getString(i));
        }
        buf.append(']');
        return buf.toString ();
    }
            
            
      

   void _showNotify () {
       list.validateFocus ();
   }
}
