// ME4SE - A MicroEdition Emulation for J2SE 
//
// Copyright (C) 2001 Stefan Haustein, Oberhausen (Rhld.), Germany
//
// Contributors:
//
// STATUS: API complete
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version. This program is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details. You should have received a copy of the
// GNU General Public License along with this program; if not, write
// to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

package javax.microedition.lcdui;

import javax.microedition.midlet.*;
import org.me4se.impl.lcdui.*;

public class TextField extends Item {

    public static final int ANY = 0;
    public static final int EMAILADDR = 1;
    public static final int NUMERIC = 2;
    public static final int PHONENUMBER = 3;
    public static final int URL = 4;
    public static final int PASSWORD = 0x010000;
    public static final int CONSTRAINT_MASK = 0x0ffff;

    TextComponent field;
    int maxSize;


    public TextField(String label, String text, int maxSize, int constraints) {
        super(label);

        // use fixed limitof 64K or so???
        int actualSize = (int) Runtime.getRuntime().freeMemory() / 4;
        if (maxSize > actualSize)
            maxSize = actualSize;

        this.maxSize = maxSize;

        if (text == null)
            text = "";

        field = new TextComponent("textField");
	field.setConstraints (constraints);
        field.setText (text);
       // field.setFont(FontInfo.getFontInfo("default").getAwtFont().font);
      //  CursorAdapter.register(field, true);
       // if (maxSize < 8)
       //     field.setColumns(maxSize);
        lines.addElement(field);
    }

    public void setString(String text) {
        field.setText(text);
    }

    public String getString() {
        return field.getText();
    }

 /*   java.awt.Component getField() {
        return field;
    }*/

    public void delete(int offset, int length) {
        String s = getString();
        setString(s.substring(0, offset) + s.substring(offset + length));
    }

    public int getCaretPosition() {
        return 0;
    }

    public int getChars(char[] data) {
        String s = getString();
        int l = s.length();
        s.getChars(0, l, data, 0);
        return l;
    }

    public int getConstraints() {
        return field.getConstraints ();
    }

    public int getMaxSize() {
        return maxSize;
    }

    public void insert(char[] data, int offset, int length, int position) {
        insert(new String(data, offset, length), position);
    }

    public void insert(String src, int position) {
        String s = getString();
        setString(s.substring(0, position) + src + s.substring(position));
    }

    public void setChars(char[] data, int offset, int length) {
        setString(new String(data, offset, length));
    }

    public void setConstraints(int constraints) {
        field.setConstraints (constraints);
    }

    public int setMaxSize(int maxSize) {
        return this.maxSize = maxSize;
    }

    public int size() {
        return getString().length();
    }
}
