package org.me4se.impl;

import javax.microedition.midlet.*;
//import org.me4se.impl.jam.MIDletSuiteManager;
import javax.microedition.lcdui.*;

/**
 * Simple class to choose a MIDlet from a JAR file. This is a helper class
 * for the ApplicationManager that allows the user to select one of several
 * MIDlets from a MIDlet suite. Once a MIDlet is chosen, the new MIDlet is
 * instantiated an passed to the ApplicationManager as the active MIDlet.
 */
public class MIDletChooser extends MIDlet implements CommandListener {

	/**
	 * The list screen where the MIDlet names are displayed.
	 */
	private List list = new List("Choose MIDlet", Choice.IMPLICIT);

	/**
	 * The launch command.
	 */
	private Command LAUNCH = new Command("Launch", Command.SCREEN, 0);

	/**
	 * The back command used for ME4SE-Jam
	 */
	private Command BACK = new Command("Back", Command.BACK, 0);

	/**
	 * The parent MIDlet (Suite selector)
	 */
	private MIDlet parent;

	/**
	 * Creates the MIDlet.
	 */
	public MIDletChooser() {
		JadFile jadFile = ApplicationManager.manager.jadFile;

		for (int i = 1; i <= jadFile.getMIDletCount(); i++) {
			list.append(jadFile.getMIDlet(i).getName(), null);
		}

		list.addCommand(LAUNCH);
		list.setCommandListener(this);

		if (ApplicationManager.manager.properties.getProperty("jam") != null)
			list.addCommand(BACK);
	}

	/**
	 * Is called when the MIDletChooser is started, activates the list screen.
	 */
	protected void startApp() {
		Display.getDisplay(this).setCurrent(list);
	}

	/**
	 * Does nothing.
	 */
	protected void pauseApp() {
	}

	/**
     * Does nothing.
     */
	protected void destroyApp(boolean unconditional) {
	}

	/**
	 * Handles the LAUNCH command.
	 */
	public void commandAction(Command cmd, Displayable dsp) {
		if (cmd == LAUNCH) {
			try {
				// Get the name of the selected MIDlet and create a MIDlet instance
				// for it.
				String s = ApplicationManager.manager.jadFile.getMIDlet(list.getSelectedIndex() + 1).getClassName();
                ApplicationManager.manager.startMIDlet(s);
                }
			catch (Exception error) {
				error.printStackTrace();
			}
		} else if (cmd == BACK) {
            notifyDestroyed();
		}
	}
}
